// ApiTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <list>
#include <windows.h>
#include <gdiplus.h>

#include "strike7api.h"

#include "mapApplet.h"

using namespace Gdiplus;

bool inDrag = false;

Bitmap *bitmap;
Bitmap *smallBitmap;
Bitmap *RenderImage(Image *image, Bitmap *bitmap)
{
	Graphics *graphics = Graphics::FromImage(bitmap);
	graphics->DrawImage(image, 0, 0, bitmap->GetWidth(), bitmap->GetHeight());
	delete graphics;
	return bitmap;
}

void __stdcall AppletActiveEvent( uint16_t appletId, uint16_t endpointId, uint32_t endpoinType )
{
	printf("applet activated: %d\n", appletId);

	if (appletId == 1)
	{
		Rect rect(0,0,480,320);
		BitmapData data;
		bitmap->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &data);
		AppletDraw( appletId, endpointId, 0, 0, 480, 320, data.Scan0 );
		bitmap->UnlockBits(&data);
	
		AppletDrawText( appletId, endpointId, 10, 10, 20, 0xFFFFFFFF, L"Hello World");
	}

	AppletUpdateScreen(appletId, endpointId);
}

void __stdcall AppletInactiveEvent( uint16_t appletId, uint16_t endpointId )
{
	printf("applet deactivated: %d\n", appletId);
}

void __stdcall AppletTouchEvent( uint16_t appletId, uint16_t endpointId, uint32_t x, uint32_t y, BOOL pressed )
{

	if (appletId == 2)
	{
		if (pressed)
		{
			if (!inDrag)
			{
				printf("%d %d\n", x, y);
					AppletFill(appletId, endpointId, x, y, 20, 20, 0xFFFFFFFF);
					inDrag = true;
			}
			else
			{
			    BitmapData data;
				Rect rect(0,0,30,30);
				smallBitmap->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &data);
				AppletDraw( appletId, endpointId, x, y, 30, 30, data.Scan0 );
				smallBitmap->UnlockBits(&data);
			}
		}
		else
		{
			AppletFill(appletId, endpointId, x, y, 20, 20, 0xFFFF0000);
			inDrag = false;
		}
	}
	
	AppletUpdateScreen(appletId, endpointId);
}

void __stdcall AppletResetEvent( uint16_t appletId, uint16_t endpointId )
{
	printf( "applet %d reset\n", appletId );
}

int _tmain(int argc, _TCHAR* argv[])
{
	GdiplusStartupInput gdiplusStartupInput;
	ULONG_PTR gdiplusToken;
	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
    Image image(L"..\\C#\\Resources\\MadCatzIcon.png");
	
	bitmap = RenderImage(&image, new Bitmap(480, 320));
	smallBitmap = RenderImage(&image, new Bitmap(30,30));

	RegisterAppletActiveEvent( AppletActiveEvent, 0 );
	RegisterAppletInactiveEvent( AppletInactiveEvent, 0 );
	RegisterAppletTouchEvent( AppletTouchEvent, 0 );
	RegisterAppletResetEvent( AppletResetEvent, 0 );

	BitmapData data;
	Rect rect(0,0,480,320);
	bitmap->LockBits(&rect, ImageLockModeRead, PixelFormat32bppARGB, &data);
	//AppletDraw( appletId, x, y, 30, 30, data.Scan0 );

	//OpenApplet( _T("HELLO WORLD"), 480, 320, data.Scan0, NULL );
	//OpenApplet( _T("Drawing App"),480, 320, data.Scan0, NULL );

    Bitmap mapImage(L"..\\C#\\Resources\\MadCatz.png");
	MapApplet mapApplet(&mapImage);

	bitmap->UnlockBits(&data);

	while(1) 
	{
		Sleep(10);
	}

	return 0;
}

